'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _mime = require('mime');

var _mime2 = _interopRequireDefault(_mime);

var _pump = require('pump');

var _pump2 = _interopRequireDefault(_pump);

var _file = require('./file');

var _http = require('http');

var _streamer = require('./streamer');

var _networkAddress = require('network-address');

var _networkAddress2 = _interopRequireDefault(_networkAddress);

var _rangeParser = require('range-parser');

var _rangeParser2 = _interopRequireDefault(_rangeParser);

var FileStreamer = (function (_Streamer) {
  _inherits(FileStreamer, _Streamer);

  function FileStreamer(filepath) {
    _classCallCheck(this, FileStreamer);

    _get(Object.getPrototypeOf(FileStreamer.prototype), 'constructor', this).call(this);
    this._filepath = filepath;
    this._file = null;
    this._server = (0, _http.createServer)(this._handler.bind(this));
    this._server.on('connection', function (socket) {
      socket.setTimeout(36000000);
    });
  }

  _createClass(FileStreamer, [{
    key: 'start',
    value: _regeneratorRuntime.mark(function start() {
      return _regeneratorRuntime.wrap(function start$(context$2$0) {
        var _this = this;

        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            context$2$0.next = 2;
            return function (cb) {
              _this._server.listen(cb);
            };

          case 2:
          case 'end':
            return context$2$0.stop();
        }
      }, start, this);
    })
  }, {
    key: 'destroy',
    value: _regeneratorRuntime.mark(function destroy() {
      return _regeneratorRuntime.wrap(function destroy$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            this._server.close();

          case 1:
          case 'end':
            return context$2$0.stop();
        }
      }, destroy, this);
    })
  }, {
    key: 'getUrl',
    value: function getUrl() {
      return 'http://' + (0, _networkAddress2['default'])() + ':' + this._server.address().port;
    }
  }, {
    key: '_getFile',
    value: _regeneratorRuntime.mark(function _getFile() {
      return _regeneratorRuntime.wrap(function _getFile$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            if (this._file) {
              context$2$0.next = 4;
              break;
            }

            context$2$0.next = 3;
            return (0, _file.getFile)(this._filepath);

          case 3:
            this._file = context$2$0.sent;

          case 4:
            return context$2$0.abrupt('return', this._file);

          case 5:
          case 'end':
            return context$2$0.stop();
        }
      }, _getFile, this);
    })
  }, {
    key: '_handler',
    value: function _handler(req, res) {
      (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
        var file, range;
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              context$3$0.next = 2;
              return this._getFile();

            case 2:
              file = context$3$0.sent;
              range = req.headers.range;

              range = range && (0, _rangeParser2['default'])(file.getSize(), range)[0];

              res.setHeader('Accept-Ranges', 'bytes');
              res.setHeader('Content-Type', _mime2['default'].lookup(file.getFileName()));

              if (range) {
                context$3$0.next = 14;
                break;
              }

              res.setHeader('Content-Length', file.getSize());

              if (!(req.method === 'HEAD')) {
                context$3$0.next = 12;
                break;
              }

              res.end();
              return context$3$0.abrupt('return');

            case 12:
              (0, _pump2['default'])(file.createReadStream(), res);
              return context$3$0.abrupt('return');

            case 14:

              res.statusCode = 206;
              res.setHeader('Content-Length', range.end - range.start + 1);
              res.setHeader('Content-Range', 'bytes ' + range.start + '-' + range.end + '/' + file.getSize());

              if (!(req.method === 'HEAD')) {
                context$3$0.next = 20;
                break;
              }

              res.end();
              return context$3$0.abrupt('return');

            case 20:
              (0, _pump2['default'])(file.createReadStream(range), res);

            case 21:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      }).bind(this))['catch'](function (err) {
        res.statusCode = 500;
        res.end(err.stack);
      });
    }
  }]);

  return FileStreamer;
})(_streamer.Streamer);

exports.FileStreamer = FileStreamer;
