'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.getFile = getFile;
var marked0$0 = [getFile].map(_regeneratorRuntime.mark);

var _file = require('./file');

var _torrentStream = require('torrent-stream');

var _torrentStream2 = _interopRequireDefault(_torrentStream);

function getFile(filepath) {
  var engine, file, stream;
  return _regeneratorRuntime.wrap(function getFile$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
      case 0:
        engine = (0, _torrentStream2['default'])(filepath);
        context$1$0.next = 3;
        return waitUntil(engine, 'ready');

      case 3:
        file = findLargestFile(engine.files);
        stream = null;

        if (file) {
          file.select();
          stream = file.createReadStream();
        }

        return context$1$0.abrupt('return', file && new _file.TorrentFile(file));

      case 7:
      case 'end':
        return context$1$0.stop();
    }
  }, marked0$0[0], this);
}

function waitUntil(target, event) {
  return function (cb) {
    target.once(event, function () {
      cb();
    });
  };
}

function findLargestFile(files) {
  if (files.length < 1) {
    return null;
  }
  return files.slice(1).reduce(function (largestFile, file) {
    return largestFile.length < file.length ? file : largestFile;
  }, files[0]);
}
