'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.getStreamer = getStreamer;

var _httpStreamer = require('./http-streamer');

var _fileStreamer = require('./file-streamer');

function getStreamer(filepath) {
  return createHttpStreamer(filepath) || createFileStreamer(filepath);
}

function createHttpStreamer(filepath) {
  if (/^https?:\/\//.test(filepath)) {
    return new _httpStreamer.HttpStreamer(filepath);
  }
}

function createFileStreamer(filepath) {
  return new _fileStreamer.FileStreamer(filepath);
}
