'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _pump = require('pump');

var _pump2 = _interopRequireDefault(_pump);

var _http = require('http');

var _networkAddress = require('network-address');

var _networkAddress2 = _interopRequireDefault(_networkAddress);

var _html5VideoTranscoder = require('html5-video-transcoder');

var _html5VideoTranscoder2 = _interopRequireDefault(_html5VideoTranscoder);

var transcoder = new _html5VideoTranscoder2['default']();

var Transcoder = (function () {
  function Transcoder(url) {
    _classCallCheck(this, Transcoder);

    this._url = url;
    this._server = (0, _http.createServer)(this._handler.bind(this));
  }

  _createClass(Transcoder, [{
    key: 'start',
    value: _regeneratorRuntime.mark(function start() {
      return _regeneratorRuntime.wrap(function start$(context$2$0) {
        var _this = this;

        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            context$2$0.next = 2;
            return function (cb) {
              _this._server.listen(cb);
            };

          case 2:
          case 'end':
            return context$2$0.stop();
        }
      }, start, this);
    })
  }, {
    key: 'destroy',
    value: _regeneratorRuntime.mark(function destroy() {
      return _regeneratorRuntime.wrap(function destroy$(context$2$0) {
        while (1) switch (context$2$0.prev = context$2$0.next) {
          case 0:
            this._server.close();

          case 1:
          case 'end':
            return context$2$0.stop();
        }
      }, destroy, this);
    })
  }, {
    key: 'getUrl',
    value: function getUrl() {
      return 'http://' + (0, _networkAddress2['default'])() + ':' + this._server.address().port;
    }
  }, {
    key: '_handler',
    value: function _handler(req, res) {
      (0, _co2['default'])(_regeneratorRuntime.mark(function callee$2$0() {
        var u, q, startTime, data, callback, body, stream;
        return _regeneratorRuntime.wrap(function callee$2$0$(context$3$0) {
          while (1) switch (context$3$0.prev = context$3$0.next) {
            case 0:
              u = _url2['default'].parse(req.url);
              q = _qs2['default'].parse(u.query);
              startTime = q.start_time | 0;

              if (!(u.pathname === '/info')) {
                context$3$0.next = 14;
                break;
              }

              context$3$0.next = 6;
              return transcoder.getInfo(this._url);

            case 6:
              data = context$3$0.sent;
              callback = q.callback;
              body = JSON.stringify(data);

              if (callback) {
                body = callback + '(' + body + ')';
              }

              res.setHeader('Content-Type', 'application/json');
              res.setHeader('Content-Length', Buffer.byteLength(body));
              res.end(body);
              return context$3$0.abrupt('return');

            case 14:

              res.statusCode = 200;
              res.setHeader('Transfer-Encoding', 'chunked');
              res.setHeader('Content-Type', 'video/mp4');

              if (!(req.method === 'HEAD')) {
                context$3$0.next = 20;
                break;
              }

              res.end();
              return context$3$0.abrupt('return');

            case 20:
              stream = transcoder.getStream(this._url, startTime);

              (0, _pump2['default'])(stream, res);

            case 22:
            case 'end':
              return context$3$0.stop();
          }
        }, callee$2$0, this);
      }).bind(this))['catch'](function (err) {
        res.statusCode = 500;
        res.end(err.statck);
      });
    }
  }]);

  return Transcoder;
})();

exports.Transcoder = Transcoder;

function parseStartTime(url) {
  var match = /[\?&]start_time=(\d+)/.exec(url);
  return (match && match[1]) | 0;
}
